;
; Demo sequence data
;
; Author:
;	s_tec
;

;               x0          x1          y0          y1
rect screen,   -16.0,       16.0,      -9.0,        9.0
rect eco,      -2.0,        14.0,      -4.0,        4.0
rect plant,    -16.5,      -0.5,       -8.0,        8.0
rect ground,   -16.5,       16.5,      -9.0,       -4.0
rect factory,  -12.0,       0,         -9.0,        3.0
rect people,   -8.0,        8.0,       -8.0,        8.0
rect pole0,     1.0,        2.0,       -8.0,       -0.0  ;1.5, -1.5
rect pole1,    -6.25,      -5.0,       -8.0,        2.0  ;-5.625, 1.375
rect pole2,    -11.0,      -10.25,     -8.0,       -2.0  ;-10.625, -3.375
rect recycle,  -4.0,        4.0,       -4.0,        4.0
rect cloud0,   -4.0,        4.0,        4.0,        9.0
rect cloud1,   -12.0,       0.0,        2.0,        8.0
rect cloud2,    0.0,        16.0,      -1.0,        7.0

;               bottom      top (aabbggrr)
color  eco,     0xff000000, 0xff606060
color  power,   0xff80e8ff, 0xff00ccff
color  stuff,   0xff000040, 0xff0000ff
color  recycle, 0xffc0ff80, 0xff80ff00
color  wind,    0xffffc080, 0xffff8000

const whole_note,   2670
const half_note,    whole_note/2
const quarter_note, whole_note/4

const k_length_eco,     8*whole_note+half_note+quarter_note
const k_length_power,   8*whole_note
const k_length_stuff,   8*whole_note+half_note
const k_length_recycle, 12*whole_note
const k_length_wind,    8*whole_note

const k_start_eco,     0
const k_start_power,   k_start_eco   + k_length_eco
const k_start_stuff,   k_start_power + k_length_power
const k_start_recycle, k_start_stuff + k_length_stuff
const k_start_wind,    k_start_recycle + k_length_recycle

script eco
	draw_grad	eco
	alpha		8*whole_note, -7*whole_note
	draw_image	screen, black
	update		eco
	draw_part	eco, dot
	alpha		4*whole_note, 2*whole_note
	draw_image	plant, plant
	draw_image	eco, eco
ends

script power
	draw_grad	power
	update		danger
	draw_part	danger, danger
	update		smoke
	draw_part	smoke, smoke
	alpha		0, 1
	draw_image	factory, factory
	draw_image	ground, ground
	
	alpha		k_start_power + 4*whole_note, -4*whole_note
	draw_image	screen, black
	alpha		k_start_power + k_length_power - 2*whole_note, 2*whole_note
	draw_image	screen, black
ends

script stuff
	draw_grad	stuff
	update		chevron
	draw_part	chev, chevron
	alpha		k_start_stuff + 2*whole_note, 2*whole_note
	draw_image	people, people
	
	alpha		k_start_stuff + k_length_stuff - half_note, half_note
	draw_image	screen, black

ends

script recycle
	draw_grad	recycle
	update		swirl
	draw_part	swirl, hex
	alpha		k_start_recycle + 4*whole_note, 2*whole_note
	draw_image	recycle, recycle
ends

script wind
	draw_grad	wind
	alpha		0, 1
	draw_image	ground, ground
	draw_image	cloud0, cloud
	draw_image	cloud1, cloud
	draw_image	cloud2, cloud
	draw_image	pole0, pole
	draw_image	pole1, pole
	draw_image	pole2, pole
	update		blades
	draw_part	blades, blade

	alpha		k_start_wind + k_length_wind - 4*whole_note, 4*whole_note
	draw_image	screen, black
ends
