;
; gdiplus.inc
;
; GDI+ NASM header file
;
; Since NASM does not support namespaces, this header prefixes all symbols
; from the Gdiplus namespace with "Gdip_"
;
; Organizaton:
;	GdiplusEnums.h
;	GdiplusTypes.h
;	GdiplusInit.h
;	GdiplusPixelFormats.h
;	GdiplusColor.h
;	GdiplusMetaHeader.h (partial)
;	GdiplusImaging.h (partial)
;	GdiplusColorMatrix.h
;	GdiplusHeaders.h
;	All other headers
;
; Converted by:
;	s_tec
;

%ifndef gdiplus_inc_included
%define gdiplus_inc_included

;-------------------------------------------------------------------------------
; GdiplusEnums.h
;-------------------------------------------------------------------------------

Gdip_FlatnessDefault				equ	0.25

;FillMode:
Gdip_FillModeAlternate				equ	0
Gdip_FillModeWinding				equ	1

;QualityMode
Gdip_QualityModeInvalid				equ	-1
Gdip_QualityModeDefault				equ	0
Gdip_QualityModeLow				equ	1
Gdip_QualityModeHigh				equ	2

;CompositingMode:
Gdip_CompositingModeSourceOver			equ	0
Gdip_CompositingModeSourceCopy			equ	1

;CompositingQuality:
Gdip_CompositingQualityInvalid			equ	Gdip_QualityModeInvalid
Gdip_CompositingQualityDefault			equ	Gdip_QualityModeDefault
Gdip_CompositingQualityHighSpeed		equ	Gdip_QualityModeLow
Gdip_CompositingQualityHighQuality		equ	Gdip_QualityModeHigh
Gdip_CompositingQualityGammaCorrected		equ	3
Gdip_CompositingQualityAssumeLinear		equ	4

;Unit:
Gdip_UnitWorld					equ	0
Gdip_UnitDisplay				equ	1
Gdip_UnitPixel					equ	2
Gdip_UnitPoint					equ	3
Gdip_UnitInch					equ	4
Gdip_UnitDocument				equ	5
Gdip_UnitMillimeter				equ	6

;MetafileFrameUnit:
Gdip_MetafileFrameUnitPixel			equ	Gdip_UnitPixel
Gdip_MetafileFrameUnitPoint			equ	Gdip_UnitPoint
Gdip_MetafileFrameUnitInch			equ	Gdip_UnitInch
Gdip_MetafileFrameUnitDocument			equ	Gdip_UnitDocument
Gdip_MetafileFrameUnitMillimeter		equ	Gdip_UnitMillimeter
Gdip_MetafileFrameUnitGdi			equ	7

;CoordinateSpace:
Gdip_CoordinateSpaceWorld			equ	0
Gdip_CoordinateSpacePage			equ	1
Gdip_CoordinateSpaceDevice			equ	2

;WrapMode:
Gdip_WrapModeTile				equ	0
Gdip_WrapModeTileFlipX				equ	1
Gdip_WrapModeTileFlipY				equ	2
Gdip_WrapModeTileFlipXY				equ	3
Gdip_WrapModeClamp				equ	4

;HatchStyle:
Gdip_HatchStyleHorizontal			equ	0
Gdip_HatchStyleVertical				equ	1
Gdip_HatchStyleForwardDiagonal			equ	2
Gdip_HatchStyleBackwardDiagonal			equ	3
Gdip_HatchStyleCross				equ	4
Gdip_HatchStyleDiagonalCross			equ	5
Gdip_HatchStyle05Percent			equ	6
Gdip_HatchStyle10Percent			equ	7
Gdip_HatchStyle20Percent			equ	8
Gdip_HatchStyle25Percent			equ	9
Gdip_HatchStyle30Percent			equ	10
Gdip_HatchStyle40Percent			equ	11
Gdip_HatchStyle50Percent			equ	12
Gdip_HatchStyle60Percent			equ	13
Gdip_HatchStyle70Percent			equ	14
Gdip_HatchStyle75Percent			equ	15
Gdip_HatchStyle80Percent			equ	16
Gdip_HatchStyle90Percent			equ	17
Gdip_HatchStyleLightDownwardDiagonal		equ	18
Gdip_HatchStyleLightUpwardDiagonal		equ	19
Gdip_HatchStyleDarkDownwardDiagonal		equ	20
Gdip_HatchStyleDarkUpwardDiagonal		equ	21
Gdip_HatchStyleWideDownwardDiagonal		equ	22
Gdip_HatchStyleWideUpwardDiagonal		equ	23
Gdip_HatchStyleLightVertical			equ	24
Gdip_HatchStyleLightHorizontal			equ	25
Gdip_HatchStyleNarrowVertical			equ	26
Gdip_HatchStyleNarrowHorizontal			equ	27
Gdip_HatchStyleDarkVertical			equ	28
Gdip_HatchStyleDarkHorizontal			equ	29
Gdip_HatchStyleDashedDownwardDiagonal		equ	30
Gdip_HatchStyleDashedUpwardDiagonal		equ	31
Gdip_HatchStyleDashedHorizontal			equ	32
Gdip_HatchStyleDashedVertical			equ	33
Gdip_HatchStyleSmallConfetti			equ	34
Gdip_HatchStyleLargeConfetti			equ	35
Gdip_HatchStyleZigZag				equ	36
Gdip_HatchStyleWave				equ	37
Gdip_HatchStyleDiagonalBrick			equ	38
Gdip_HatchStyleHorizontalBrick			equ	39
Gdip_HatchStyleWeave				equ	40
Gdip_HatchStylePlaid				equ	41
Gdip_HatchStyleDivot				equ	42
Gdip_HatchStyleDottedGrid			equ	43
Gdip_HatchStyleDottedDiamond			equ	44
Gdip_HatchStyleShingle				equ	45
Gdip_HatchStyleTrellis				equ	46
Gdip_HatchStyleSphere				equ	47
Gdip_HatchStyleSmallGrid			equ	48
Gdip_HatchStyleSmallCheckerBoard		equ	49
Gdip_HatchStyleLargeCheckerBoard		equ	50
Gdip_HatchStyleOutlinedDiamond			equ	51
Gdip_HatchStyleSolidDiamond			equ	52
Gdip_HatchStyleTotal				equ	53
Gdip_HatchStyleLargeGrid			equ	Gdip_HatchStyleCross
Gdip_HatchStyleMin				equ	Gdip_HatchStyleHorizontal
Gdip_HatchStyleMax				equ	Gdip_HatchStyleTotal - 1

;DashStyle:
Gdip_DashStyleSolid				equ	0
Gdip_DashStyleDash				equ	1
Gdip_DashStyleDot				equ	2
Gdip_DashStyleDashDot				equ	3
Gdip_DashStyleDashDotDot			equ	4
Gdip_DashStyleCustom				equ	5

;DashCap:
Gdip_DashCapFlat				equ	0
Gdip_DashCapRound				equ	2
Gdip_DashCapTriangle				equ	3

;LineCap:
Gdip_LineCapFlat				equ	0
Gdip_LineCapSquare				equ	1
Gdip_LineCapRound				equ	2
Gdip_LineCapTriangle				equ	3
Gdip_LineCapNoAnchor				equ	0x10
Gdip_LineCapSquareAnchor			equ	0x11
Gdip_LineCapRoundAnchor				equ	0x12
Gdip_LineCapDiamondAnchor			equ	0x13
Gdip_LineCapArrowAnchor				equ	0x14
Gdip_LineCapCustom				equ	0xff
Gdip_LineCapAnchorMask				equ	0xf0

;CustomLineCapType:
Gdip_CustomLineCapTypeDefault			equ	0
Gdip_CustomLineCapTypeAdjustableArrow		equ	1

;LineJoin:
Gdip_LineJoinMiter				equ	0
Gdip_LineJoinBevel				equ	1
Gdip_LineJoinRound				equ	2
Gdip_LineJoinMiterClipped			equ	3

;PathPointType:
Gdip_PathPointTypeStart				equ	0
Gdip_PathPointTypeLine				equ	1
Gdip_PathPointTypeBezier			equ	3
Gdip_PathPointTypePathTypeMask			equ	0x07
Gdip_PathPointTypeDashMode			equ	0x10
Gdip_PathPointTypePathMarker			equ	0x20
Gdip_PathPointTypeCloseSubpath			equ	0x80
Gdip_PathPointTypeBezier3			equ	3

;WarpMode:
Gdip_WarpModePerspective			equ	0
Gdip_WarpModeBilinear				equ	1

;LinearGradientMode:
Gdip_LinearGradientModeHorizontal		equ	0
Gdip_LinearGradientModeVertical			equ	1
Gdip_LinearGradientModeForwardDiagonal		equ	2
Gdip_LinearGradientModeBackwardDiagonal		equ	3

;CombineMode:
Gdip_CombineModeReplace				equ	0
Gdip_CombineModeIntersect			equ	1
Gdip_CombineModeUnion				equ	2
Gdip_CombineModeXor				equ	3
Gdip_CombineModeExclude				equ	4
Gdip_CombineModeComplement			equ	5

;ImageType:
Gdip_ImageTypeUnknown				equ	0
Gdip_ImageTypeBitmap				equ	1
Gdip_ImageTypeMetafile				equ	2

;InterpolationMode:
Gdip_InterpolationModeInvalid			equ	Gdip_QualityModeInvalid
Gdip_InterpolationModeDefault			equ	Gdip_QualityModeDefault
Gdip_InterpolationModeLowQuality		equ	Gdip_QualityModeLow
Gdip_InterpolationModeHighQuality		equ	Gdip_QualityModeHigh
Gdip_InterpolationModeBilinear			equ	3
Gdip_InterpolationModeBicubic			equ	4
Gdip_InterpolationModeNearestNeighbor		equ	5
Gdip_InterpolationModeHighQualityBilinear	equ	6
Gdip_InterpolationModeHighQualityBicubic	equ	7

;PenAlignment:
Gdip_PenAlignmentCenter				equ	0
Gdip_PenAlignmentInset				equ	1

;BrushType:
Gdip_BrushTypeSolidColor			equ	0
Gdip_BrushTypeHatchFill				equ	1
Gdip_BrushTypeTextureFill			equ	2
Gdip_BrushTypePathGradient			equ	3
Gdip_BrushTypeLinearGradient			equ	4

;PenType:
Gdip_PenTypeSolidColor				equ	Gdip_BrushTypeSolidColor
Gdip_PenTypeHatchFill				equ	Gdip_BrushTypeHatchFill
Gdip_PenTypeTextureFill				equ	Gdip_BrushTypeTextureFill
Gdip_PenTypePathGradient			equ	Gdip_BrushTypePathGradient
Gdip_PenTypeLinearGradient			equ	Gdip_BrushTypeLinearGradient
Gdip_PenTypeUnknown				equ	-1

;MatrixOrder:
Gdip_MatrixOrderPrepend				equ	0
Gdip_MatrixOrderAppend				equ	1

;GenericFontFamily:
Gdip_GenericFontFamilySerif			equ	0
Gdip_GenericFontFamilySansSerif			equ	1
Gdip_GenericFontFamilyMonospace			equ	2

;FontStyle:
Gdip_FontStyleRegular				equ	0
Gdip_FontStyleBold				equ	1
Gdip_FontStyleItalic				equ	2
Gdip_FontStyleBoldItalic			equ	3
Gdip_FontStyleUnderline				equ	4
Gdip_FontStyleStrikeout				equ	8

;SmoothingMode:
Gdip_SmoothingModeInvalid			equ	Gdip_QualityModeInvalid
Gdip_SmoothingModeDefault			equ	Gdip_QualityModeDefault
Gdip_SmoothingModeHighSpeed			equ	Gdip_QualityModeLow
Gdip_SmoothingModeHighQuality			equ	Gdip_QualityModeHigh
Gdip_SmoothingModeNone				equ	3
Gdip_SmoothingModeAntiAlias			equ	4

;PixelOffsetMode:
Gdip_PixelOffsetModeInvalid			equ	Gdip_QualityModeInvalid
Gdip_PixelOffsetModeDefault			equ	Gdip_QualityModeDefault
Gdip_PixelOffsetModeHighSpeed			equ	Gdip_QualityModeLow
Gdip_PixelOffsetModeHighQuality			equ	Gdip_QualityModeHigh
Gdip_PixelOffsetModeNone			equ	3
Gdip_PixelOffsetModeHalf			equ	4

;TextRenderingHint:
Gdip_TextRenderingHintSystemDefault		equ	0
Gdip_TextRenderingHintSingleBitPerPixelGridFit	equ	1
Gdip_TextRenderingHintSingleBitPerPixel		equ	2
Gdip_TextRenderingHintAntiAliasGridFit		equ	3
Gdip_TextRenderingHintAntiAlias			equ	4
Gdip_TextRenderingHintClearTypeGridFit		equ	5

;MetafileType:
Gdip_MetafileTypeInvalid			equ	0
Gdip_MetafileTypeWmf				equ	1
Gdip_MetafileTypeWmfPlaceable			equ	2
Gdip_MetafileTypeEmf				equ	3
Gdip_MetafileTypeEmfPlusOnly			equ	4
Gdip_MetafileTypeEmfPlusDual			equ	5

;EmfType:
Gdip_EmfTypeEmfOnly				equ	Gdip_MetafileTypeEmf
Gdip_EmfTypeEmfPlusOnly				equ	Gdip_MetafileTypeEmfPlusOnly
Gdip_EmfTypeEmfPlusDual				equ	Gdip_MetafileTypeEmfPlusDual

;ObjectType:
Gdip_ObjectTypeInvalid				equ	0
Gdip_ObjectTypeBrush				equ	1
Gdip_ObjectTypePen				equ	2
Gdip_ObjectTypePath				equ	3
Gdip_ObjectTypeRegion				equ	4
Gdip_ObjectTypeImage				equ	5
Gdip_ObjectTypeFont				equ	6
Gdip_ObjectTypeStringFormat			equ	7
Gdip_ObjectTypeImageAttributes			equ	8
Gdip_ObjectTypeCustomLineCap			equ	9
Gdip_ObjectTypeMax				equ	Gdip_ObjectTypeCustomLineCap
Gdip_ObjectTypeMin				equ	Gdip_ObjectTypeBrush

%define Gdip_ObjectTypeIsValid(type) ((type) >= Gdip_ObjectTypeMin && (type) <= Gdip_ObjectTypeMax)

;EmfPlusRecordType:
;[skipped]

;StringFormatFlags:
Gdip_StringFormatFlagsDirectionRightToLeft	equ	0x00000001
Gdip_StringFormatFlagsDirectionVertical		equ	0x00000002
Gdip_StringFormatFlagsNoFitBlackBox		equ	0x00000004
Gdip_StringFormatFlagsDisplayFormatControl	equ	0x00000020
Gdip_StringFormatFlagsNoFontFallback		equ	0x00000400
Gdip_StringFormatFlagsMeasureTrailingSpaces	equ	0x00000800
Gdip_StringFormatFlagsNoWrap			equ	0x00001000
Gdip_StringFormatFlagsLineLimit			equ	0x00002000
Gdip_StringFormatFlagsNoClip			equ	0x00004000

;StringTrimming:
Gdip_StringTrimmingNone				equ	0
Gdip_StringTrimmingCharacter			equ	1
Gdip_StringTrimmingWord				equ	2
Gdip_StringTrimmingEllipsisCharacter		equ	3
Gdip_StringTrimmingEllipsisWord			equ	4
Gdip_StringTrimmingEllipsisPath			equ	5

;StringDigitSubstitute:
Gdip_StringDigitSubstituteUser			equ	0
Gdip_StringDigitSubstituteNone			equ	1
Gdip_StringDigitSubstituteNational		equ	2
Gdip_StringDigitSubstituteTraditional		equ	3

;HotkeyPrefix:
Gdip_HotkeyPrefixNone				equ	0
Gdip_HotkeyPrefixShow				equ	1
Gdip_HotkeyPrefixHide				equ	2

;StringAlignment:
Gdip_StringAlignmentNear			equ	0
Gdip_StringAlignmentCenter			equ	1
Gdip_StringAlignmentFar				equ	2

;DriverStringOptions:
Gdip_DriverStringOptionsCmapLookup		equ	1
Gdip_DriverStringOptionsVertical		equ	2
Gdip_DriverStringOptionsRealizedAdvance		equ	4
Gdip_DriverStringOptionsLimitSubpixel		equ	8

;FlushIntention:
Gdip_FlushIntentionFlush			equ	0
Gdip_FlushIntentionSync				equ	1

;EncoderParameterValueType:
Gdip_EncoderParameterValueTypeByte		equ	1
Gdip_EncoderParameterValueTypeASCII		equ	2
Gdip_EncoderParameterValueTypeShort		equ	3
Gdip_EncoderParameterValueTypeLong		equ	4
Gdip_EncoderParameterValueTypeRational		equ	5
Gdip_EncoderParameterValueTypeLongRange		equ	6
Gdip_EncoderParameterValueTypeUndefined		equ	7
Gdip_EncoderParameterValueTypeRationalRange	equ	8

;EncoderValue:
Gdip_EncoderValueColorTypeCMYK			equ	0
Gdip_EncoderValueColorTypeYCCK			equ	1
Gdip_EncoderValueCompressionLZW			equ	2
Gdip_EncoderValueCompressionCCITT3		equ	3
Gdip_EncoderValueCompressionCCITT4		equ	4
Gdip_EncoderValueCompressionRle			equ	5
Gdip_EncoderValueCompressionNone		equ	6
Gdip_EncoderValueScanMethodInterlaced		equ	7
Gdip_EncoderValueScanMethodNonInterlaced	equ	8
Gdip_EncoderValueVersionGif87			equ	9
Gdip_EncoderValueVersionGif89			equ	10
Gdip_EncoderValueRenderProgressive		equ	11
Gdip_EncoderValueRenderNonProgressive		equ	12
Gdip_EncoderValueTransformRotate90		equ	13
Gdip_EncoderValueTransformRotate180		equ	14
Gdip_EncoderValueTransformRotate270		equ	15
Gdip_EncoderValueTransformFlipHorizontal	equ	16
Gdip_EncoderValueTransformFlipVertical		equ	17
Gdip_EncoderValueMultiFrame			equ	18
Gdip_EncoderValueLastFrame			equ	19
Gdip_EncoderValueFlush				equ	20
Gdip_EncoderValueFrameDimensionTime		equ	21
Gdip_EncoderValueFrameDimensionResolution	equ	22
Gdip_EncoderValueFrameDimensionPage		equ	23

;EmfToWmfBitsFlags:
Gdip_EmfToWmfBitsFlagsDefault			equ	0x00000000
Gdip_EmfToWmfBitsFlagsEmbedEmf			equ	0x00000001
Gdip_EmfToWmfBitsFlagsIncludePlaceable		equ	0x00000002
Gdip_EmfToWmfBitsFlagsNoXORClip			equ	0x00000004

;GpTestControlEnum:
Gdip_TestControlForceBilinear			equ	0
Gdip_TestControlNoICM				equ	1
Gdip_TestControlGetBuildNumber			equ	2

;-------------------------------------------------------------------------------
; GdiplusTypes.h
;-------------------------------------------------------------------------------

%define Gdip_REAL DWORD

REAL_MAX					equ	3.402823466e+38
REAL_MIN					equ	1.175494351e-38
REAL_TOLERANCE					equ	1.175494351e-36
REAL_EPSILON					equ	1.192092896e-07

;Status:
Gdip_Ok						equ	0
Gdip_GenericError				equ	1
Gdip_InvalidParameter				equ	2
Gdip_OutOfMemory				equ	3
Gdip_ObjectBusy					equ	4
Gdip_InsufficientBuffer				equ	5
Gdip_NotImplemented				equ	6
Gdip_Win32Error					equ	7
Gdip_WrongState					equ	8
Gdip_Aborted					equ	9
Gdip_FileNotFound				equ	10
Gdip_ValueOverflow				equ	11
Gdip_AccessDenied				equ	12
Gdip_UnknownImageFormat				equ	13
Gdip_FontFamilyNotFound				equ	14
Gdip_FontStyleNotFound				equ	15
Gdip_NotTrueTypeFont				equ	16
Gdip_UnsupportedGdiplusVersion			equ	17
Gdip_GdiplusNotInitialized			equ	18
Gdip_PropertyNotFound				equ	19
Gdip_PropertyNotSupported			equ	20

						struc	Gdip_SizeF
.Width						resd	1
.Height						resd	1
						endstruc

						struc	Gdip_Size
.Width						resd	1
.Height						resd	1
						endstruc

						struc	Gdip_PointF
.X						resd	1
.Y						resd	1
						endstruc

						struc	Gdip_Point
.X						resd	1
.Y						resd	1
						endstruc

						struc	Gdip_RectF
.X						resd	1
.Y						resd	1
.Width						resd	1
.Height						resd	1
						endstruc

						struc	Gdip_Rect
.X						resd	1
.Y						resd	1
.Width						resd	1
.Height						resd	1
						endstruc

						struc	Gdip_PathData
.Count						resd	1
.Points						resd	1
.Types						resd	1
						endstruc

						struc	Gdip_CharacterRange
.First						resd	1
.Length						resd	1
						endstruc

;-------------------------------------------------------------------------------
; GdiplusInit.h
;-------------------------------------------------------------------------------

;DebugEventLevel:
Gdip_DebugEventLevelFatal			equ	0
Gdip_DebugEventLevelWarning			equ	1

						struc	Gdip_GdiplusStartupInput
.GdiplusVersion					resd	1
.DebugEventCallback				resd	1
.SuppressBackgroundThread			resd	1
.SuppressExternalCodecs				resd	1
						endstruc

;From the GdiplusStartupInput constructor:
Gdip_GdiplusVersion				equ	1


						struc	Gdip_GdiplusStartupOutput
.NotificationHook				resd	1
.NotificationUnhook				resd	1
						endstruc

;-------------------------------------------------------------------------------
; GdiplusPixelFormats.h
;-------------------------------------------------------------------------------

ALPHA_SHIFT					equ	24
RED_SHIFT					equ	16
GREEN_SHIFT					equ	8
BLUE_SHIFT					equ	0
ALPHA_MASK					equ	0xff << ALPHA_SHIFT

%define Gdip_ARGB        DWORD;
%define Gdip_ARGB64      DWORDLONG
%define Gdip_PixelFormat INT

PixelFormatIndexed				equ	0x00010000
PixelFormatGDI					equ	0x00020000
PixelFormatAlpha				equ	0x00040000
PixelFormatPAlpha				equ	0x00080000
PixelFormatExtended				equ	0x00100000
PixelFormatCanonical				equ	0x00200000
PixelFormatUndefined				equ	0
PixelFormatDontCare				equ	0
PixelFormat1bppIndexed				equ	1 | ( 1 << 8) | PixelFormatIndexed | PixelFormatGDI
PixelFormat4bppIndexed				equ	2 | ( 4 << 8) | PixelFormatIndexed | PixelFormatGDI
PixelFormat8bppIndexed				equ	3 | ( 8 << 8) | PixelFormatIndexed | PixelFormatGDI
PixelFormat16bppGrayScale			equ	4 | (16 << 8) | PixelFormatExtended
PixelFormat16bppRGB555				equ	5 | (16 << 8) | PixelFormatGDI
PixelFormat16bppRGB565				equ	6 | (16 << 8) | PixelFormatGDI
PixelFormat16bppARGB1555			equ	7 | (16 << 8) | PixelFormatAlpha | PixelFormatGDI
PixelFormat24bppRGB				equ	8 | (24 << 8) | PixelFormatGDI
PixelFormat32bppRGB				equ	9 | (32 << 8) | PixelFormatGDI
PixelFormat32bppARGB				equ	10 | (32 << 8) | PixelFormatAlpha | PixelFormatGDI | PixelFormatCanonical
PixelFormat32bppPARGB				equ	11 | (32 << 8) | PixelFormatAlpha | PixelFormatPAlpha | PixelFormatGDI
PixelFormat48bppRGB				equ	12 | (48 << 8) | PixelFormatExtended
PixelFormat64bppARGB				equ	13 | (64 << 8) | PixelFormatAlpha | PixelFormatCanonical | PixelFormatExtended
PixelFormat64bppPARGB				equ	14 | (64 << 8) | PixelFormatAlpha | PixelFormatPAlpha | PixelFormatExtended
PixelFormatMax					equ	15

%define Gdip_GetPixelFormatSize(pixfmt)    ((pixfmt >> 8) & 0xff)
%define Gdip_IsIndexedPixelFormat(pixfmt)  ((pixfmt & PixelFormatIndexed)  != 0)
%define Gdip_IsAlphaPixelFormat(pixfmt)    ((pixfmt & PixelFormatAlpha)    != 0)
%define Gdip_IsExtendedPixelFormat(pixfmt) ((pixfmt & PixelFormatExtended) != 0)
%define Gdip_IsCanonicalPixelFormat(pixfmt) ((pixfmt & PixelFormatCanonical) != 0)

;PaletteFlags:
Gdip_PaletteFlagsHasAlpha			equ	0x0001
Gdip_PaletteFlagsGrayScale			equ	0x0002
Gdip_PaletteFlagsHalftone			equ	0x0004

						struc	Gdip_ColorPalette
.Flags						resd	1
.Count						resd	1
						endstruc

;-------------------------------------------------------------------------------
; GdiplusColor.h
;-------------------------------------------------------------------------------

;ColorMode:
Gdip_ColorModeARGB32				equ	0
Gdip_ColorModeARGB64				equ	1

;ColorChannelFlags:
Gdip_ColorChannelFlagsC				equ	0
Gdip_ColorChannelFlagsM				equ	1
Gdip_ColorChannelFlagsY				equ	2
Gdip_ColorChannelFlagsK				equ	3
Gdip_ColorChannelFlagsLast			equ	4

;Color
Gdip_AliceBlue					equ	0xFFF0F8FF
Gdip_AntiqueWhite				equ	0xFFFAEBD7
Gdip_Aqua					equ	0xFF00FFFF
Gdip_Aquamarine					equ	0xFF7FFFD4
Gdip_Azure					equ	0xFFF0FFFF
Gdip_Beige					equ	0xFFF5F5DC
Gdip_Bisque					equ	0xFFFFE4C4
Gdip_Black					equ	0xFF000000
Gdip_BlanchedAlmond				equ	0xFFFFEBCD
Gdip_Blue					equ	0xFF0000FF
Gdip_BlueViolet					equ	0xFF8A2BE2
Gdip_Brown					equ	0xFFA52A2A
Gdip_BurlyWood					equ	0xFFDEB887
Gdip_CadetBlue					equ	0xFF5F9EA0
Gdip_Chartreuse					equ	0xFF7FFF00
Gdip_Chocolate					equ	0xFFD2691E
Gdip_Coral					equ	0xFFFF7F50
Gdip_CornflowerBlue				equ	0xFF6495ED
Gdip_Cornsilk					equ	0xFFFFF8DC
Gdip_Crimson					equ	0xFFDC143C
Gdip_Cyan					equ	0xFF00FFFF
Gdip_DarkBlue					equ	0xFF00008B
Gdip_DarkCyan					equ	0xFF008B8B
Gdip_DarkGoldenrod				equ	0xFFB8860B
Gdip_DarkGray					equ	0xFFA9A9A9
Gdip_DarkGreen					equ	0xFF006400
Gdip_DarkKhaki					equ	0xFFBDB76B
Gdip_DarkMagenta				equ	0xFF8B008B
Gdip_DarkOliveGreen				equ	0xFF556B2F
Gdip_DarkOrange					equ	0xFFFF8C00
Gdip_DarkOrchid					equ	0xFF9932CC
Gdip_DarkRed					equ	0xFF8B0000
Gdip_DarkSalmon					equ	0xFFE9967A
Gdip_DarkSeaGreen				equ	0xFF8FBC8B
Gdip_DarkSlateBlue				equ	0xFF483D8B
Gdip_DarkSlateGray				equ	0xFF2F4F4F
Gdip_DarkTurquoise				equ	0xFF00CED1
Gdip_DarkViolet					equ	0xFF9400D3
Gdip_DeepPink					equ	0xFFFF1493
Gdip_DeepSkyBlue				equ	0xFF00BFFF
Gdip_DimGray					equ	0xFF696969
Gdip_DodgerBlue					equ	0xFF1E90FF
Gdip_Firebrick					equ	0xFFB22222
Gdip_FloralWhite				equ	0xFFFFFAF0
Gdip_ForestGreen				equ	0xFF228B22
Gdip_Fuchsia					equ	0xFFFF00FF
Gdip_Gainsboro					equ	0xFFDCDCDC
Gdip_GhostWhite					equ	0xFFF8F8FF
Gdip_Gold					equ	0xFFFFD700
Gdip_Goldenrod					equ	0xFFDAA520
Gdip_Gray					equ	0xFF808080
Gdip_Green					equ	0xFF008000
Gdip_GreenYellow				equ	0xFFADFF2F
Gdip_Honeydew					equ	0xFFF0FFF0
Gdip_HotPink					equ	0xFFFF69B4
Gdip_IndianRed					equ	0xFFCD5C5C
Gdip_Indigo					equ	0xFF4B0082
Gdip_Ivory					equ	0xFFFFFFF0
Gdip_Khaki					equ	0xFFF0E68C
Gdip_Lavender					equ	0xFFE6E6FA
Gdip_LavenderBlush				equ	0xFFFFF0F5
Gdip_LawnGreen					equ	0xFF7CFC00
Gdip_LemonChiffon				equ	0xFFFFFACD
Gdip_LightBlue					equ	0xFFADD8E6
Gdip_LightCoral					equ	0xFFF08080
Gdip_LightCyan					equ	0xFFE0FFFF
Gdip_LightGoldenrodYellow			equ	0xFFFAFAD2
Gdip_LightGray					equ	0xFFD3D3D3
Gdip_LightGreen					equ	0xFF90EE90
Gdip_LightPink					equ	0xFFFFB6C1
Gdip_LightSalmon				equ	0xFFFFA07A
Gdip_LightSeaGreen				equ	0xFF20B2AA
Gdip_LightSkyBlue				equ	0xFF87CEFA
Gdip_LightSlateGray				equ	0xFF778899
Gdip_LightSteelBlue				equ	0xFFB0C4DE
Gdip_LightYellow				equ	0xFFFFFFE0
Gdip_Lime					equ	0xFF00FF00
Gdip_LimeGreen					equ	0xFF32CD32
Gdip_Linen					equ	0xFFFAF0E6
Gdip_Magenta					equ	0xFFFF00FF
Gdip_Maroon					equ	0xFF800000
Gdip_MediumAquamarine				equ	0xFF66CDAA
Gdip_MediumBlue					equ	0xFF0000CD
Gdip_MediumOrchid				equ	0xFFBA55D3
Gdip_MediumPurple				equ	0xFF9370DB
Gdip_MediumSeaGreen				equ	0xFF3CB371
Gdip_MediumSlateBlue				equ	0xFF7B68EE
Gdip_MediumSpringGreen				equ	0xFF00FA9A
Gdip_MediumTurquoise				equ	0xFF48D1CC
Gdip_MediumVioletRed				equ	0xFFC71585
Gdip_MidnightBlue				equ	0xFF191970
Gdip_MintCream					equ	0xFFF5FFFA
Gdip_MistyRose					equ	0xFFFFE4E1
Gdip_Moccasin					equ	0xFFFFE4B5
Gdip_NavajoWhite				equ	0xFFFFDEAD
Gdip_Navy					equ	0xFF000080
Gdip_OldLace					equ	0xFFFDF5E6
Gdip_Olive					equ	0xFF808000
Gdip_OliveDrab					equ	0xFF6B8E23
Gdip_Orange					equ	0xFFFFA500
Gdip_OrangeRed					equ	0xFFFF4500
Gdip_Orchid					equ	0xFFDA70D6
Gdip_PaleGoldenrod				equ	0xFFEEE8AA
Gdip_PaleGreen					equ	0xFF98FB98
Gdip_PaleTurquoise				equ	0xFFAFEEEE
Gdip_PaleVioletRed				equ	0xFFDB7093
Gdip_PapayaWhip					equ	0xFFFFEFD5
Gdip_PeachPuff					equ	0xFFFFDAB9
Gdip_Peru					equ	0xFFCD853F
Gdip_Pink					equ	0xFFFFC0CB
Gdip_Plum					equ	0xFFDDA0DD
Gdip_PowderBlue					equ	0xFFB0E0E6
Gdip_Purple					equ	0xFF800080
Gdip_Red					equ	0xFFFF0000
Gdip_RosyBrown					equ	0xFFBC8F8F
Gdip_RoyalBlue					equ	0xFF4169E1
Gdip_SaddleBrown				equ	0xFF8B4513
Gdip_Salmon					equ	0xFFFA8072
Gdip_SandyBrown					equ	0xFFF4A460
Gdip_SeaGreen					equ	0xFF2E8B57
Gdip_SeaShell					equ	0xFFFFF5EE
Gdip_Sienna					equ	0xFFA0522D
Gdip_Silver					equ	0xFFC0C0C0
Gdip_SkyBlue					equ	0xFF87CEEB
Gdip_SlateBlue					equ	0xFF6A5ACD
Gdip_SlateGray					equ	0xFF708090
Gdip_Snow					equ	0xFFFFFAFA
Gdip_SpringGreen				equ	0xFF00FF7F
Gdip_SteelBlue					equ	0xFF4682B4
Gdip_Tan					equ	0xFFD2B48C
Gdip_Teal					equ	0xFF008080
Gdip_Thistle					equ	0xFFD8BFD8
Gdip_Tomato					equ	0xFFFF6347
Gdip_Transparent				equ	0x00FFFFFF
Gdip_Turquoise					equ	0xFF40E0D0
Gdip_Violet					equ	0xFFEE82EE
Gdip_Wheat					equ	0xFFF5DEB3
Gdip_White					equ	0xFFFFFFFF
Gdip_WhiteSmoke					equ	0xFFF5F5F5
Gdip_Yellow					equ	0xFFFFFF00
Gdip_YellowGreen				equ	0xFF9ACD32

;Color
Gdip_AlphaShift					equ	24
Gdip_RedShift					equ	16
Gdip_GreenShift					equ	8
Gdip_BlueShift					equ	0

;Color
Gdip_AlphaMask					equ	0xff000000
Gdip_RedMask					equ	0x00ff0000
Gdip_GreenMask					equ	0x0000ff00
Gdip_BlueMask					equ	0x000000ff

						struc	Gdip_Color
.Argb						resd	1
						endstruc

;-------------------------------------------------------------------------------
; GdiplusMetaHeader.h
;-------------------------------------------------------------------------------

;[skipped]

;-------------------------------------------------------------------------------
; GdiplusImaging.h
;-------------------------------------------------------------------------------

;[skipped]

;ImageLockMode:
Gdip_ImageLockModeRead				equ	0x0001
Gdip_ImageLockModeWrite				equ	0x0002
Gdip_ImageLockModeUserInputBuf			equ	0x0004

						struc	Gdip_BitmapData
.Width:						resd	1
.Height:					resd	1
.Stride:					resd	1
.PixelFormat:					resd	1
.Scan0:						resd	1
.Reserved:					resd	1
						endstruc

;RotateFlipType:
Gdip_RotateNoneFlipNone				equ	0
Gdip_Rotate90FlipNone				equ	1
Gdip_Rotate180FlipNone				equ	2
Gdip_Rotate270FlipNone				equ	3
Gdip_RotateNoneFlipX				equ	4
Gdip_Rotate90FlipX				equ	5
Gdip_Rotate180FlipX				equ	6
Gdip_Rotate270FlipX				equ	7
Gdip_RotateNoneFlipY				equ	Gdip_Rotate180FlipX
Gdip_Rotate90FlipY				equ	Gdip_Rotate270FlipX
Gdip_Rotate180FlipY				equ	Gdip_RotateNoneFlipX
Gdip_Rotate270FlipY				equ	Gdip_Rotate90FlipX
Gdip_RotateNoneFlipXY				equ	Gdip_Rotate180FlipNone
Gdip_Rotate90FlipXY				equ	Gdip_Rotate270FlipNone
Gdip_Rotate180FlipXY				equ	Gdip_RotateNoneFlipNone
Gdip_Rotate270FlipXY				equ	Gdip_Rotate90FlipNone

;-------------------------------------------------------------------------------
; GdiplusColorMatrix.h
;-------------------------------------------------------------------------------

						struc	Gdip_ColorMatrix
.m:						resd	5*5
						endstruc

;ColorMatrixFlags:
Gdip_ColorMatrixFlagsDefault			equ	0
Gdip_ColorMatrixFlagsSkipGrays			equ	1
Gdip_ColorMatrixFlagsAltGray			equ	2

;ColorAdjustType:
Gdip_ColorAdjustTypeDefault			equ	0
Gdip_ColorAdjustTypeBitmap			equ	1
Gdip_ColorAdjustTypeBrush			equ	2
Gdip_ColorAdjustTypePen				equ	3
Gdip_ColorAdjustTypeText			equ	4
Gdip_ColorAdjustTypeCount			equ	5
Gdip_ColorAdjustTypeAny				equ	6

						struc	Gdip_ColorMap
.oldColor:					resd	1
.newColor:					resd	1
						endstruc

;-------------------------------------------------------------------------------
; All other headers
;-------------------------------------------------------------------------------

						struc	Gdip_Region
.nativeRegion					resd	1
.lastResult					resd	1
						endstruc

						struc	Gdip_FontFamily
.nativeFamily					resd	1
.lastResult					resd	1
						endstruc

						struc	Gdip_Font
.nativeFont					resd	1
.lastResult					resd	1
						endstruc

						struc	Gdip_FontCollection
.nativeFontCollection				resd	1
.lastResult					resd	1
						endstruc

%define Gdip_InstalledFontCollection Gdip_FontCollection
%define Gdip_PrivateFontCollection Gdip_FontCollection

						struc	Gdip_Image
.nativeImage					resd	1
.lastResult					resd	1
.loadStatus					resd	1
						endstruc

%define Gdip_Bitmap Gdip_Image
%define Gdip_Metafile Gdip_Image

						struc	Gdip_CustomLineCap
.nativeCap					resd	1
.lastResult					resd	1
						endstruc

%define Gdip_AdjustableArrowCap Gdip_CustomLineCap

						struc	Gdip_CachedBitmap
.nativeCachedBitmap				resd	1
.lastResult					resd	1
						endstruc

						struc	Gdip_ImageAttributes
.nativeImageAttr				resd	1
.lastResult					resd	1
						endstruc

						struc	Gdip_Matrix
.nativeMatrix					resd	1
.lastResult					resd	1
						endstruc

						struc	Gdip_Brush
.nativeBrush					resd	1
.lastResult					resd	1
						endstruc

%define Gdip_SolidBrush Gdip_Brush
%define Gdip_TextureBrush Gdip_Brush
%define Gdip_LinearGradientBrush Gdip_Brush
%define Gdip_PathGradientBrush Gdip_Brush
%define Gdip_HatchBrush Gdip_Brush

						struc	Gdip_Pen
.nativePen					resd	1
.lastResult					resd	1
						endstruc

						struc	Gdip_StringFormat
.nativeFormat					resd	1
.lastResult					resd	1
						endstruc

						struc	Gdip_GraphicsPath
.nativePath					resd	1
.lastResult					resd	1
						endstruc

						struc	Gdip_GraphicsPathIterator
.nativeIterator					resd	1
.lastResult					resd	1
						endstruc

						struc	Gdip_Graphics
.nativeGraphics					resd	1
.lastResult					resd	1
						endstruc

%endif
