;
; 4K intro startup code
;
; Author:
;	s_tec
;

%include "win32n.inc"
%include "nasmgl.inc"
%include "macros.inc"
%include "const.inc"

		global	g_t
		global	g_dt
		global	_main
		global	_main_exit

		extern	g_temp
		extern	_demo_init
		extern	_demo_draw
		extern	_synth_play
		extern	_tex_init

;-----------------------------------------------------------------------------
; DLL imports
;-----------------------------------------------------------------------------

		;gdiplus.dll:
		import	GdiplusStartup,		__imp__GdiplusStartup@12

		;gdi32.dll:
		import	ChoosePixelFormat,	__imp__ChoosePixelFormat@8
		import	SetPixelFormat,		__imp__SetPixelFormat@12
		import	SwapBuffers,		__imp__SwapBuffers@4

		;kernel32.dll:
		import	ExitProcess,		__imp__ExitProcess@4
		import	GetTickCount,		__imp__GetTickCount@0

		;opengl32.dll:
		import	wglCreateContext,	__imp__wglCreateContext@4
		import	wglMakeCurrent,		__imp__wglMakeCurrent@8

		;user32.dll:
		import	ChangeDisplaySettings,	__imp__ChangeDisplaySettingsA@8
		import	CreateWindowExA,	__imp__CreateWindowExA@48
		import	GetDC,			__imp__GetDC@4
%ifdef debug
		import	GetSystemMetrics,	__imp__GetSystemMetrics@4
		import	PeekMessageA,		__imp__PeekMessageA@20
		import	DispatchMessageA,	__imp__DispatchMessageA@4
%else
		import	GetAsyncKeyState,	__imp__GetAsyncKeyState@4
		import	ShowCursor,		__imp__ShowCursor@4
%endif

;-----------------------------------------------------------------------------
; Constants
;-----------------------------------------------------------------------------

;-----------------------------------------------------------------------------
; Uninitialized data
;-----------------------------------------------------------------------------
		section	.bss

g_t:		resd	1	;Playback position, in ms
g_dt:		resd	1	;Previous frame length, in ms

s_main_start:	resd	1	;Demo start time
s_main_dc	resd	1	;Device context

%ifdef debug
s_main_msg:	;Window message structure
.hwnd		resd	1
.message	resd	1
.wParam		resd	1
.lParam		resd	1
.time		resd	1
.pt		resd	2
%endif

;-----------------------------------------------------------------------------
; Initialized data
;-----------------------------------------------------------------------------
		section	.data

		;The main window's class:
s_main_class:	db	"edit", 0
		align	4, db 0

%ifndef debug
s_main_mode:		;Display mode:
.dmDeviceName		times	CCHDEVICENAME db 0
.dmSpecVersion		dw	0
.dmDriverVersion	dw	0
.dmSize			dw	DEVMODE_size
.dmDriverExtra		dw	0
.dmFields		dd	DM_PELSWIDTH|DM_PELSHEIGHT
.dmOrientation		dw	0
.dmPaperSize		dw	0
.dmPaperiLength		dw	0
.dmPaperWidth		dw	0
.dmScale		dw	0
.dmCopies		dw	0
.dmDefaultSource	dw	0
.dmPrintQuality		dw	0
.dmColor		dw	0
.dmDuplex		dw	0
.dmYResolution		dw	0
.dmTTOption		dw	0
.dmCollate		dw	0
.dmFormName		times	32 db 0
.dmLogPixels		dw	0
.dmBitsPerPel		dd	0
.dmPelsWidth		dd	k_size_x
.dmPelsHeight		dd	k_size_y
.dmDisplayFlags		dd	0
.dmDisplayFrequency	dd	0
.dmDisplayOrientation	dd	0
%endif

s_main_format:		;Pixel format (40 bytes):
.nSize:			dw	0
.nVersion:		dw	0
.dwFlags:		dd	PFD_DRAW_TO_WINDOW|PFD_SUPPORT_OPENGL|PFD_DOUBLEBUFFER
.iPixelType:		db	0
.cColorBits:		db	0
.cRedBits:		db	0
.cRedShift:		db	0
.cGreenBits:		db	0
.cGreenShift:		db	0
.cBlueBits:		db	0
.cBlueShift:		db	0
.cAlphaBits:		db	0
.cAlphaShift:		db	0
.cAccumBits:		db	0
.cAccumRedBits:		db	0
.cAccumGreenBits:	db	0
.cAccumBlueBits:	db	0
.cAccumAlphaBits:	db	0
.cDepthBits:		db	16
.cStencilBits:		db	0
.cAuxBuffers:		db	0
.iLayerType:		db	0
.bReserved:		db	0
.dwLayerMask:		dd	0
.dwVisibleMask:		dd	0
.dwDamageMask:		dd	0

s_main_gdip:			;GdiplusStartupInfo
.GdiplusVersion			dd	1
.DebugEventCallback		dd	0
.SuppressBackgroundThread	dd	0
.SuppressExternalCodecs		dd	0

;-----------------------------------------------------------------------------
; Program entry point
;-----------------------------------------------------------------------------
		section	.text
_main:
%ifdef debug
		;Find the window's Y location:
		push	SM_CYSCREEN
		call	GetSystemMetrics
		sub	eax, k_size_y
		sar	eax, 1
		mov	esi, eax

		;Find the window's X location:
		push	SM_CXSCREEN
		call	GetSystemMetrics
		sub	eax, k_size_x
		sar	eax, 1

		;Create the window:
		push	0			;lpParam
		push	0			;hInstance
		push	0			;hMenu
		push	0			;hWndParent
		push	k_size_y		;nHeight
		push	k_size_x		;nWidth
		push	esi			;y
		push	eax			;x
		push	WS_POPUP | WS_VISIBLE | WS_CLIPSIBLINGS ;dwStyle
		push	0			;lpWindowName
		push	s_main_class		;lpClassName
		push	0			;dwExStyle
		call	CreateWindowExA
%else
		;Go to fullscreen mode:
		push	CDS_FULLSCREEN		;dwflags
		push	s_main_mode		;lpDevMode
		call	ChangeDisplaySettings

		;Create the window:
		push	0			;lpParam
		push	0			;hInstance
		push	0			;hMenu
		push	0			;hWndParent
		push	0			;nHeight
		push	0			;nWidth
		push	0			;y
		push	0			;x
		push	WS_POPUP | WS_VISIBLE | WS_CLIPSIBLINGS | WS_MAXIMIZE ;dwStyle
		push	0			;lpWindowName
		push	s_main_class		;lpClassName
		push	0			;dwExStyle
		call	CreateWindowExA
%endif

		;Get the device context:
		push	eax
		call	GetDC
		mov	esi, eax
		mov	[s_main_dc], esi

		;Set up the pixel format:
		push	s_main_format		;ppfd
		push	esi			;hdc
		call	ChoosePixelFormat
		push	s_main_format		;ppfd
		push	eax			;iPixelFormat
		push	esi			;hdc
		call	SetPixelFormat

		;Set up the rendering context:
		push	esi			;hdc
		call	wglCreateContext
		push	eax			;hglrc
		push	esi			;hdc
		call	wglMakeCurrent

		;Start GDI+:
		push	0			;output
		push	s_main_gdip		;input
		push	g_temp			;token
		call	GdiplusStartup

		;Generate textures:
		call	_tex_init

		;Prepare the demo:
		call	_demo_init

		;Start the music:
		call	_synth_play

		;Save the starting time:
		call	GetTickCount
		mov	[s_main_start], eax

%ifdef debug
		;Start in the future:
		add	dword[g_t], 1000*k_music_start
%else
		;Hide the cursor:
		push	0			;bShow
		call	ShowCursor
%endif

;-----------------------------------------------------------------------------
; Main loop
;-----------------------------------------------------------------------------
_main_loop:
		;Set up the current time:
		call	GetTickCount
		sub	eax, [s_main_start]
		add	[s_main_start], eax
		add	[g_t], eax
		mov	[g_dt], eax

		;Render:
		call	_demo_draw

		;Copy to the display:
		push	dword[s_main_dc]	;hdc
		call	SwapBuffers

%ifdef debug
		;Check for messages:
		push	PM_REMOVE		;wRemoveMsg
		push	0			;wMsgFilterMax
		push	0			;wMsgFilterMin
		push	0			;hWnd
		push	s_main_msg		;lpMsg
		call	PeekMessageA
		test	eax, eax
		jz	_main_loop

		;Process the message:
		push	s_main_msg		;lpmsg
		call	DispatchMessageA
		cmp	dword[s_main_msg.message], WM_KEYDOWN
		jne	_main_loop
		cmp	dword[s_main_msg.wParam], VK_ESCAPE
		jne	_main_loop
%else
		;while (!GetAsyncKeyState(VK_ESCAPE)):
		push	VK_ESCAPE
		call	GetAsyncKeyState
		test	eax, eax
		jz	_main_loop
%endif

		;Exit:
_main_exit:	push	0			;uExitCode
		call	ExitProcess
