;
; 4K music implementation
;
; Author:
;	s_tec
;

%include "win32n.inc"
%include "macros.inc"
%include "const.inc"
%include "scale.inc"

		extern	_synth_end
		extern	_synth_run
		extern	_synth_jump
		extern	_synth_step

		extern	_synth_tink
		extern	_synth_glitch
		extern	_synth_hihat
		extern	_synth_siner
		extern	_synth_organ

		extern	_synth_mix
		extern	_synth_echo
		extern	_synth_bitcrush
		extern	_synth_bandpass
		extern	_synth_chorus

;Commands:
%define const(name, v)
%define buffer(name, l)
%define script(name)
%define ends
%define run(name)
%define jump(name)
%define step(d)

%define tink(d, f)
%define glitch(d, f)
%define hihat(d)
%define siner(l, f)
%define organ(vd, vf, l, f)

%define mix(name, a)
%define echo(name, d, a)
%define bitcrush(name, d)
%define bandpass(name, k, a1, a2)
%define chorus(name, vd, vf, d, a)

;-----------------------------------------------------------------------------
; Pass 0: globals
;-----------------------------------------------------------------------------

%define const(name, v) name equ v
%define buffer(name, l) global g_buffer_ %+ name
%define script(name)    global g_script_ %+ name

%include "music.inc"

%define const(name, v)
%define buffer(name, l)
%define script(name)

;-----------------------------------------------------------------------------
; Pass 1: Buffer allocation
;-----------------------------------------------------------------------------
		section	.bss

%macro buffer_imp 2
                 resd k_wave_sps
g_buffer_%1:     resd (%2)*k_wave_sps
g_buffer_%1_size equ  (%2)*k_wave_sps
%endm
%define	buffer(name, l) buffer_imp name, l

%include "music.inc"

%define buffer(name, l)

;-----------------------------------------------------------------------------
; Pass 2: Script commands
;-----------------------------------------------------------------------------
		section	.data

%define script(name) g_script_ %+ name:
%define ends                        dd _synth_end
%define run(name)                   dd _synth_run,      g_script_ %+ name
%define jump(name)                  dd _synth_jump,     g_buffer_ %+ name
%define step(d)                     dd _synth_step,     (d)*4

%define tink(d, f)                  dd _synth_tink,     d, f
%define glitch(d, f)                dd _synth_glitch,   d, f
%define hihat(d)                    dd _synth_hihat,    d
%define siner(l, f)                 dd _synth_siner,    l, f
%define organ(vd, vf, l, f)         dd _synth_organ,    l, f, vd, vf

%define mix(name, a)                dd _synth_mix,      g_buffer_ %+ name, g_buffer_ %+ name %+ _size, a
%define echo(name, d, a)            dd _synth_echo,     g_buffer_ %+ name, g_buffer_ %+ name %+ _size, (d)*4, a
%define bitcrush(name, d)           dd _synth_bitcrush, g_buffer_ %+ name, g_buffer_ %+ name %+ _size, d
%define bandpass(name, k, a1, a2)   dd _synth_bandpass, g_buffer_ %+ name, g_buffer_ %+ name %+ _size, k, a1, a2
%define chorus(name, vd, vf, d, a)  dd _synth_chorus,   g_buffer_ %+ name, g_buffer_ %+ name %+ _size, vd, vf, d, a

%include "music.inc"
