;
; 4K texture generation functions.
;
; Author:
;	s_tec
;

%include "nasmgl.inc"
%include "gdiplus.inc"
%include "macros.inc"
%include "const.inc"

;%define bounds

		global	g_path_x
		global	g_path_y
		global	g_path_types
		global	_tex_init
		global	_tex_init_path
		global	_tex_init_bitmap
		global	_tex_init_brush
		global	_tex_init_pen
		global	_tex_xfrm
		global	_tex_stroke
		global	_tex_fill
		global	_tex_copy
		global	_tex_load
		global	_tex_blur
		global	_tex_blur_pass

		extern	g_temp
		extern	_synth_end
		extern	_synth_jump

;-----------------------------------------------------------------------------
; DLL imports
;-----------------------------------------------------------------------------

		;gdiplus.dll:
		import	GdipBitmapLockBits,		__imp__GdipBitmapLockBits@20
		import	GdipBitmapUnlockBits,		__imp__GdipBitmapUnlockBits@8
		import	GdipCreateBitmapFromScan0,	__imp__GdipCreateBitmapFromScan0@24
		import	GdipCreatePath2I,		__imp__GdipCreatePath2I@20
		import	GdipCreatePen1,			__imp__GdipCreatePen1@16
		import	GdipCreateSolidFill,		__imp__GdipCreateSolidFill@8
		import	GdipDrawImageI,			__imp__GdipDrawImageI@16
		import	GdipDrawPath,			__imp__GdipDrawPath@12
		import	GdipFillPath,			__imp__GdipFillPath@12
		import	GdipGetImageGraphicsContext,	__imp__GdipGetImageGraphicsContext@8
		import	GdipImageRotateFlip,		__imp__GdipImageRotateFlip@8
		import	GdipResetWorldTransform,	__imp__GdipResetWorldTransform@4
		import	GdipScaleWorldTransform,	__imp__GdipScaleWorldTransform@16
		import	GdipSetPenLineJoin,		__imp__GdipSetPenLineJoin@8
		import	GdipSetPenEndCap,		__imp__GdipSetPenEndCap@8
		import	GdipSetPenStartCap,		__imp__GdipSetPenStartCap@8
		import	GdipSetSmoothingMode,		__imp__GdipSetSmoothingMode@8
		import	GdipTranslateWorldTransform,	__imp__GdipTranslateWorldTransform@16
%ifdef bounds
		import	GdipGraphicsClear,		__imp__GdipGraphicsClear@8
%endif
%ifdef debug
		import	GdipSaveImageToFile,		__imp__GdipSaveImageToFile@16
%endif

		;opengl32.dll:
		import	glBindTexture,		__imp__glBindTexture@8
		import	glTexParameteri,	__imp__glTexParameteri@12

		;glu32.dll:
		import	gluBuild2DMipmaps,	__imp__gluBuild2DMipmaps@28

;-----------------------------------------------------------------------------
; Macros
;-----------------------------------------------------------------------------

%macro path 1
%ifdef pass_path_n
		global	g_path_%1
g_path_%1:	dd	k_path_%1_size
%endif
%define path_size k_path_%1_size
%endm

%macro path_x 1+
%ifdef pass_path_x
%%start:	db	%1
path_size	equ	$ - %%start
%endif
%endm

%macro path_y 1+
%ifdef pass_path_y
		db	%1
%endif
%endm

%macro path_t 1+
%ifdef pass_path_t
		db	%1
%endif
%endm

%macro bitmap 3
%ifdef pass_bitmap
		global	g_bitmap_%1
g_bitmap_%1:	dd	%2, %3
%endif
%endm

%macro brush 2
%ifdef pass_brush
		global	g_brush_%1
g_brush_%1:	dd	%2
%endif
%endm

%macro pen 3
%ifdef pass_pen
		global	g_pen_%1
g_pen_%1:	dd	%2, %3
%endif
%endm

%macro script 1
%ifdef pass_script
		global	g_script_%1
g_script_%1:
%endif
%endm

%macro jump 1
%ifdef pass_script
		dd	_synth_jump, g_bitmap_%1
%endif
%endm

%macro xfrm 3
%ifdef pass_script
		dd	_tex_xfrm, %1, %2, %3
%endif
%endm

%macro stroke 2
%ifdef pass_script
		dd	_tex_stroke, g_path_%1, g_pen_%2
%endif
%endm

%macro fill 2
%ifdef pass_script
		dd	_tex_fill, g_path_%1, g_brush_%2
%endif
%endm

%macro copy 1
%ifdef pass_script
		dd	_tex_copy, g_bitmap_%1
%endif
%endm

%macro load 1
%ifdef pass_script
		dd	_tex_load, %1
%endif
%endm

%macro blur 0
%ifdef pass_script
		dd	_tex_blur
%endif
%endm

%macro ends 0
%ifdef pass_script
		dd	_synth_end
%endif
%endm

;-----------------------------------------------------------------------------
; Constants
;-----------------------------------------------------------------------------

k_path_point_n	equ	g_path_y - g_path_x

;-----------------------------------------------------------------------------
; Uninitialized data
;-----------------------------------------------------------------------------
		section	.bss

s_path_points:	resd	2*k_path_point_n

s_blur_data:	;BitmapData structure
.Width:		resd	1
.Height:	resd	1
.Stride:	resd	1
.PixelFormat:	resd	1
.Scan0:		resd	1
.Reserved:	resd	1

;-----------------------------------------------------------------------------
; Initialized data
;-----------------------------------------------------------------------------
		section	.data

%ifdef debug
s_png_file:	db	't', 0, '.', 0, 'p', 0, 'n', 0, 'g', 0, 0, 0
		align	4, db 0
s_png_guid:	db	0x06, 0xf4, 0x7c, 0x55, 0x04, 0x1a, 0xd3, 0x11
		db	0x9a, 0x73, 0x00, 0x00, 0xf8, 0x1e, 0xf3, 0x2e
%endif

g_path_x:
%define pass_path_x
%include "texture.inc"
%undef pass_path_x

g_path_y:
%define pass_path_y
%include "texture.inc"
%undef pass_path_y

g_path_types:
%define pass_path_t
%include "texture.inc"
%undef pass_path_t

		align	4, db 0

s_path_begin:
%define pass_path_n
%include "texture.inc"
%undef pass_path_n
s_path_end:

s_bitmap_begin:
%define pass_bitmap
%include "texture.inc"
%undef pass_bitmap
s_bitmap_end:

s_brush_begin:
%define pass_brush
%include "texture.inc"
%undef pass_brush
s_brush_end:

s_pen_begin:
%define pass_pen
%include "texture.inc"
%undef pass_pen
s_pen_end:

%define pass_script
%include "texture.inc"
%undef pass_script

;-----------------------------------------------------------------------------
; Texture generation
;-----------------------------------------------------------------------------
		section	.text
_tex_init:
		;Expand path data:
		mov	ecx, k_path_point_n
		mov	esi, g_path_x
		mov	edi, s_path_points
		xor	eax, eax
.repeat0:	lodsb
		stosd
		mov	al, [esi + k_path_point_n - 1]
		stosd
		loop	.repeat0

;-----------------------------------------------------------------------------
; Bulk path creation
;-----------------------------------------------------------------------------
_tex_init_path:
		mov	ebx, 0
		mov	esi, s_path_begin

		;Path:
.repeat:	push	esi			;path
		push	Gdip_FillModeAlternate	;fillMode
		push	dword[esi]		;count
		lea	eax, [g_path_types + ebx]
		push	eax			;types
		lea	eax, [s_path_points + 8*ebx]
		push	eax			;points
		add	ebx, [esi]
		call	GdipCreatePath2I

		;Loop:
		add	esi, 4
		cmp	esi, s_path_end
		jne	.repeat

;-----------------------------------------------------------------------------
; Bulk bitmap creation
;-----------------------------------------------------------------------------
_tex_init_bitmap:
		;mov	esi, s_bitmap_begin

		;Bitmap:
.repeat:	push	esi			;bitmap
		push	0			;scan0
		push	PixelFormat32bppPARGB	;format
		push	0			;stride
		push	dword[esi+4]		;height
		push	dword[esi]		;width
		call	GdipCreateBitmapFromScan0

		;Graphics:
		add	esi, 4
		push	esi			;graphics
		push	dword[esi-4]		;image
		call	GdipGetImageGraphicsContext

%ifdef bounds
		;Clear:
		push	0x80808080		;color
		push	dword[esi]		;graphics
		call	GdipGraphicsClear
%endif

		;Antialiasing:
		push	Gdip_SmoothingModeHighQuality	;smoothingMode
		push	dword[esi]		;graphics
		call	GdipSetSmoothingMode

		;Loop:
		add	esi, 4
		cmp	esi, s_bitmap_end
		jne	.repeat

;-----------------------------------------------------------------------------
; Bulk brush creation
;-----------------------------------------------------------------------------
_tex_init_brush:
		;mov	esi, s_brush_begin

		;Brush:
.repeat:	push	esi			;brush
		push	dword[esi]		;color
		call	GdipCreateSolidFill

		;Loop:
		add	esi, 4
		cmp	esi, s_brush_end
		jne	.repeat

;-----------------------------------------------------------------------------
; Bulk pen creation
;-----------------------------------------------------------------------------
_tex_init_pen:
		;mov	esi, s_pen_begin

		;Pen:
.repeat:	push	esi			;pen
		push	Gdip_UnitWorld		;unit
		push	dword[esi+4]		;width
		push	dword[esi]		;color
		call	GdipCreatePen1

		;Start cap:
		push	Gdip_LineCapRound	;endCap
		push	dword[esi]		;pen
		call	GdipSetPenStartCap

		;End cap:
		push	Gdip_LineCapRound	;endCap
		push	dword[esi]		;pen
		call	GdipSetPenEndCap

		;Line join:
		push	Gdip_LineJoinRound	;lineJoin
		push	dword[esi]		;pen
		call	GdipSetPenLineJoin

		;Loop:
		add	esi, 8
		cmp	esi, s_pen_end
		jne	.repeat

;-----------------------------------------------------------------------------
; Done!
;-----------------------------------------------------------------------------

		;Draw the textures:
		mov	ebp, g_script_texture
		call	[ebp]

%ifdef debug
		;Debug output:
		push	0			;encoderParams
		push	s_png_guid		;clsidEncoder
		push	s_png_file		;filename
		push	dword[g_bitmap_eco]	;image
		call	GdipSaveImageToFile
%endif
		ret

;-----------------------------------------------------------------------------
; Sets the transform on a surface
;-----------------------------------------------------------------------------
%define		a_x	dword[ebp+4]		;X offset
%define		a_y	dword[ebp+8]		;Y offset
%define		a_s	dword[ebp+12]		;Scale

_tex_xfrm:
		push	edi

		push	dword[edi+4]		;graphics
		call	GdipResetWorldTransform

		push	Gdip_MatrixOrderPrepend	;order
		push	a_x			;dy
		push	a_y			;dx
		push	dword[edi+4]		;graphics
		call	GdipTranslateWorldTransform

		push	Gdip_MatrixOrderPrepend	;order
		push	a_s			;sy
		push	a_s			;sx
		push	dword[edi+4]		;graphics
		call	GdipScaleWorldTransform

		add	ebp, 16
		pop	edi
		jmp	[ebp]


;-----------------------------------------------------------------------------
; Strokes a path
;-----------------------------------------------------------------------------
%define		a_path	dword[ebp+4]		;Path
%define		a_pen	dword[ebp+8]		;Pen

_tex_stroke:
		push	edi

		mov	esi, a_path
		push	dword[esi]		;path
		mov	esi, a_pen
		push	dword[esi]		;pen
		push	dword[edi+4]		;graphics
		call	GdipDrawPath

		add	ebp, 12
		pop	edi
		jmp	[ebp]

;-----------------------------------------------------------------------------
; Fills a path
;-----------------------------------------------------------------------------
%define		a_path	dword[ebp+4]		;Path
%define		a_brush	dword[ebp+8]		;Brush

_tex_fill:
		push	edi

		mov	esi, a_path
		push	dword[esi]		;path
		mov	esi, a_brush
		push	dword[esi]		;brush
		push	dword[edi+4]		;graphics
		call	GdipFillPath

		add	ebp, 12
		pop	edi
		jmp	[ebp]

;-----------------------------------------------------------------------------
; Copies on bitmap onto another
;-----------------------------------------------------------------------------
%define		a_name	dword[ebp+4]		;Source bitmap

_tex_copy:
		push	edi

		push	0			;x
		push	0			;y
		mov	esi, a_name
		push	dword[esi]		;image
		push	dword[edi+4]		;graphics
		call	GdipDrawImageI

		add	ebp, 8
		pop	edi
		jmp	[ebp]

;-----------------------------------------------------------------------------
; Loads a bitmap into OpenGL
;-----------------------------------------------------------------------------
%define		a_name	dword[ebp+4]		;Source bitmap

_tex_load:
		push	edi

		;Get the bits:
		push	s_blur_data		;lockedBitmapData
		push	PixelFormat32bppPARGB	;format
		push	Gdip_ImageLockModeRead	;flags
		push	0			;rect
		push	dword[edi]		;bitmap
		call	GdipBitmapLockBits

		;Bind to texture slot:
		push	a_name			;texture
		push	GL_TEXTURE_2D		;target
		call	glBindTexture

		;Load the texture:
		push	dword[s_blur_data.Scan0]	;data
		push	GL_UNSIGNED_BYTE		;type
		push	GL_BGRA_EXT			;format
		push	dword[s_blur_data.Height]	;height
		push	dword[s_blur_data.Width]	;width
		push	4				;components
		push	GL_TEXTURE_2D			;target
		call	gluBuild2DMipmaps

		;Pretty mipmapping:
		push	GL_LINEAR_MIPMAP_LINEAR	;param
		push	GL_TEXTURE_MIN_FILTER	;pname
		push	GL_TEXTURE_2D		;target
		call	glTexParameteri

		add	ebp, 8
		pop	edi
		jmp	[ebp]

;-----------------------------------------------------------------------------
; Blurs a bitmap
;-----------------------------------------------------------------------------
_tex_blur:
		push	edi

		push	s_blur_data		;lockedBitmapData
		push	PixelFormat32bppPARGB	;format
		push	Gdip_ImageLockModeRead | Gdip_ImageLockModeWrite ;flags
		push	0			;rect
		push	dword[edi]		;bitmap
		call	GdipBitmapLockBits

		call	_tex_blur_pass
		call	_tex_blur_pass
		call	_tex_blur_pass

		push	s_blur_data		;lockedBitmapData
		push	dword[edi]		;bitmap
		call	GdipBitmapUnlockBits

		push	Gdip_Rotate270FlipNone	;rfType
		push	dword[edi]		;image
		call	GdipImageRotateFlip

		push	s_blur_data		;lockedBitmapData
		push	PixelFormat32bppPARGB	;format
		push	Gdip_ImageLockModeRead | Gdip_ImageLockModeWrite ;flags
		push	0			;rect
		push	dword[edi]		;bitmap
		call	GdipBitmapLockBits

		call	_tex_blur_pass
		call	_tex_blur_pass
		call	_tex_blur_pass

		push	s_blur_data		;lockedBitmapData
		push	dword[edi]		;bitmap
		call	GdipBitmapUnlockBits

		push	Gdip_Rotate90FlipNone	;rfType
		push	dword[edi]		;image
		call	GdipImageRotateFlip

		add	ebp, 4
		pop	edi
		jmp	[ebp]

;-----------------------------------------------------------------------------
; Blurs a surface.
; ah must be zero before calling this function.
;-----------------------------------------------------------------------------
_tex_blur_pass:
		push	edi
		mov	edi, [s_blur_data.Scan0]
		mov	ecx, [s_blur_data.Height]
		imul	ecx, [s_blur_data.Stride]
		sub	ecx, 4*8

		;Inner loop:
.repeat1:	mov	al, [edi]
		add	al, [edi+4]
		adc	ah, 0
		add	al, [edi+8]
		adc	ah, 0
		add	al, [edi+12]
		adc	ah, 0
		add	al, [edi+16]
		adc	ah, 0
		add	al, [edi+20]
		adc	ah, 0
		add	al, [edi+24]
		adc	ah, 0
		add	al, [edi+28]
		adc	ah, 0
		shr	eax, 3
		stosb
		loop	.repeat1

		pop	edi
		ret
